c23456789012345678901234567890123456789012345678901234567890123456789012
       PROGRAM RUNGEKUTTA3
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       PARAMETER (NPMAX=5000,NMAX=50,NMAXEIG=200)
        COMMON /DADOS/ NEIGEN,EV(NMAXEIG),UNU,APTT,K,NFLOW
        COMMON /INTDATA/ A,B,XF,YF,npoints,YF2
	   REAL*8 x(0:NPMAX),yfinal(0:NPMAX,NMAX),yprime(0:NPMAX,NMAX)
	   REAL*8 x0,h,y0(NMAX),y(NMAX),yout(NMAX),dy(NMAX)
	   REAL*8 UNU,APTT
	   REAL*8 A,B,SSFINAL,XF(NPMAX),YF(NPMAX),YF2(NPMAX)
	   INTEGER npoints,nfun,NEIGEN,IFLAG(NMAXEIG),NFLOW,K,IBOUND
      CHARACTER*50 TITLE,TITLE2			!I added for comments
c   This version of RUNGEKUTTA (version 3) is a continuation of RUNGEKUTTA2
c    and it is for a system of ODE. It operates in conjunction with sledge3.f
c   a code that determines a whole bunch of eigenvalues EV().
c   This version of rungekutta (v3.0) integrates the system of four differential
c   equations (y1,y2,y3,y4) for the development of the thermal flow in a pipe
c   with fully developed hydrodynamics, for an SPTT fluid AND does the integral of the
c   function combining y2. This integration is based on the philosophy of the code
c   integrspl2.f

c    3rd July 2001

c   Define initial values, step size and number of points
       OPEN(7,FILE='rungein.dat')
       REWIND 7
       READ(7,*) TITLE2
       READ(7,*) nfun			!number of functions
       READ(7,*) h,npoints		!step size, number of points
       DO J=1,nfun
	  READ(7,*)x0,y0(J)		!initial conditions for each function
       END DO
	  CLOSE(7)

       OPEN(10,FILE='sledout.dat',STATUS='OLD')
       REWIND 10
        READ(10,*)TITLE		!any comment
	READ(10,*)NFLOW,UNU,APTT,NEIGEN,IBOUND	!reads n, UN/U, a, number of eigen functions, type of boundary condition

      DO 30 I = 1,NEIGEN
         READ (10,12) II,EV(I),IFLAG(I)
   30  CONTINUE
   12    FORMAT(I6,2X,D25.15,2X,I3)				!Format for printout in file
   
	   CLOSE(10)

c	OPEN(8,FILE='rungeout.dat')	!This outputs everything
c	REWIND 8
c        WRITE(8,*)TITLE2       

        OPEN(21,FILE='rungeoutwall.dat')
	REWIND 21
	WRITE(21,*)TITLE2

        OPEN(22,FILE='rungeoutput.dat')		!formatted for further use by nusselt.f
	REWIND 22
	WRITE(22,*)TITLE2
	
        DO 20 K=1,NEIGEN

c   Now the real thing
c   Initial values
         x(0)=x0
         DO J=1,nfun
	    yfinal(0,J)=y0(J)
	 END DO
c   End of initial values		


        DO I=1,npoints
           DO J=1,nfun
		 y(J)=yfinal(I-1,J)
	   END DO

		  call derivs(x(I-1),y,dy)
		  call rk4(y,dy,nfun,x(I-1),h,yout)
	      x(I)=x(I-1)+h

           DO J=1,nfun
		 yfinal(I,J)=yout(J)
		 yprime(I-1,J)=dy(J)
	   END DO
        END DO

       I=npoints    	   	   
        DO J=1,nfun
		 y(J)=yfinal(I,J)
	END DO
       call derivs(x(I),y,dy)	!get dydx at last point
        DO J=1,nfun
		 yprime(I,J)=dy(J)
	END DO
c   End of integration of ODE
        WRITE(*,*)'ODEs integrated for Eigenvalue', k



c   Now, we must integrate a function which combines the eigenvalue
c   and y2. For that we use Romberg's integration method performed upon 
c   the extended trapezoidal method but before we must create the function
c   that will be integrated. This function will be prepared first and then
c   interpolation will be done with splines

c   Create function YF at points XF
       DO I=0,npoints
          XF(I+1)=x(I)							!xfunction
          YF(I+1)=UNU*UNU*x(I)**(2.+NFLOW)*(1.+2.*APTT*x(I)*x(I))*	!yfunction
     +          yfinal(I,2)
       END DO
       A=XF(1)			!lower limit of integration
       B=XF(npoints+1)		!upper limit of integration
c   Done

c   Doing the spline calculation to output its second derivative

       CALL spline(XF,YF,NPOINTS+1,1.0E+30,1.0E+30,YF2)

c   Spline is done. Now the integration
        
c   Now comes the integration
	CALL qromb(A,B,SSFINAL)
c   That's it. Done. SSFINAL is the value we want

        WRITE(*,*)'Integration of y2 done for Eigenvalue', k


c   Now the output

c        WRITE(8,*)'Eigenvalue ',k,' = ',EV(k)
        WRITE(21,*)'Eigenvalue ',k,' = ',EV(k)
        WRITE(22,*)k,EV(k)				!formatted for further use
        WRITE(21,*)' I           x              y                  dydx'
	   DO J=1,nfun
c	    WRITE(8,*)'Function =',J
c            WRITE(8,*)' I          x            y                dydx'
         DO I=0,npoints
c          WRITE(8,50)I,x(I),yfinal(I,J),yprime(I,J) 	   
         END DO
         IF (J .EQ. 2) THEN					!formmated for further use
            DO I=0,npoints					!formmated for further use
               WRITE(22,50)I,x(I),yfinal(I,J)		 	!formmated for further use	   
            END DO	   					!formmated for further use
	 ENDIF							!formmated for further use
	   WRITE(8,*)
          I=npoints
          WRITE(21,50)I,x(I),yfinal(I,J),yprime(I,J) 	   
          WRITE(22,50)I,x(I),yfinal(I,J),yprime(I,J) 	!formatted for further use   
	   END DO
	  WRITE(21,*) 'Integral I=',SSFINAL
	  WRITE(22,*) SSFINAL
          WRITE(21,*)
 20     CONTINUE

c	   CLOSE(8)
	   CLOSE(21)
	   CLOSE(22)

	   STOP
 50     FORMAT(1X,I4,3(3X,F16.11))
	   END


       SUBROUTINE rk4(y,dydx,n,x,h,yout)
c       SUBROUTINE rk4(y,dydx,n,x,h,yout,derivs)
       INTEGER n
       PARAMETER (NMAX=50)		!Set to the maximum number of functions.
       REAL*8 h,x,dydx(NMAX),y(NMAX),yout(NMAX)
c       EXTERNAL derivs
c	Given values for the variables y(1:n) and their derivatives dydx(1:n) known
c	at x, use the fourth Runge-Kutta method to advance the solution over an interval h
c	and return the incremented variables as yout(1:n), which need not be a distinct
c	array from y. The user supplies the subroutine derivs(x,y,dydx), which returns
c	derivatives dydx at x.
c   Note that n must be less or equal to NMAX
       INTEGER i
       REAL*8 h6,hh,xh,dym(NMAX),dyt(NMAX),yt(NMAX)
       hh = 0.5* h
       h6 = h/6.
       xh = x + hh
       do 11 i = 1,n			!First step
       	yt(i) = y(i) + hh * dydx(i)
 11	   continue
       call derivs(xh,yt,dyt)	!Second step
       do 12 i = 1,n
       	yt(i) = y(i) + hh * dyt(i)
 12	   continue
       call derivs(xh,yt,dym)	!Third step
       do 13 i = 1,n
       	 yt(i) = y(i) + h*dym(i)
       	 dym(i) = dyt(i) + dym(i)
 13	   continue
       call derivs(x+h,yt,dyt)	!Fourth step
       do 14 i=1,n				!Accumulate increments with proper weights.
       	 yout(i) = y(i) + h6*(dydx(i)+dyt(i)+2.*dym(i))
 14    continue
       return
       END
	   


c	SUBROUTINE qromb(func,a,b,ss)
	SUBROUTINE qromb(a,b,ss)
	INTEGER JMAX,JMAXP,K,KM
	REAL*8 a,b,ss,EPS
c	REAL*8 a,b,func,ss,EPS
c	EXTERNAL func
	PARAMETER(EPS=1.e-10,JMAX=20,JMAXP=JMAX+1,K=5,KM=K-1)
c	Uses polint, trapzd
c	Returns as ss the integral of the function func from a to b. Integration
c	is performed by Romberg's method of order 2K, where, e.g., K=2 is Simpson's
c	rule.
c	Parameters:EPS is the fractional accuracy desired, as determined 
c	by extrapolation error estimate; JMAX limits the total number of steps; 
c	K is the number of points used in the extrapolation
	INTEGER j
	REAL*8 dss,h(JMAXP),s(JMAXP)	!These store the successive trapezoidal
c								 approximations and their relative stepsizes
	h(1) = 1.
	do 11 j=1,JMAX
c		call trapzd(func,a,b,s(j),j)
		call trapzd(a,b,s(j),j)
		if (j .ge. K) then
			call polint(h(j-KM),s(j-KM),K,0.,ss,dss)
			if (abs(dss) .le. EPS*abs(ss)) return
		end if
		s(j+1) = s(j)
		h(j+1) = 0.25 * h(j)	!This is a key step: The factor is 0.25 even though
c								 the step size is decreased by only 0.5. This makes
c								 the extrapolation a polynomial in h**2 as allowed 
c								 by equation 4.2.1, not just a polynomial in h.
 11	continue
 	write(*,*)'too many steps in qromb'
	stop
	END
	
	
c	SUBROUTINE trapzd(func,a,b,s,n)
	SUBROUTINE trapzd(a,b,s,n)
	INTEGER n
	REAL*8 a,b,s,func
c	EXTERNAL func
c	This routine computes the nth stage of refinement of an extended 
c	trapezoidal rule. func is input AS the name of the function to be
c	integrated between a and b, also input. When called with n=1, the
c	routine returns as s the crudest estimate of (a,b) f(x) dx.
c	Subsequent calls with n= 2, 3,... (in that sequential order) will
c	improve the accuracy of s by ading 2**(n-2) additional integer
c	points. s should not be modified between sequential calls
	INTEGER it,j
	REAL*8 del,sum,tnm,x
	if (n .eq. 1) then
		s=0.5*(b-a)*(func(a)+func(b))
	else
		it=2**(n-2)
		tnm=it
		del=(b-a)/tnm		!This is the spacing of the points to be added
		x=a+0.5*del
		sum=0.
		do 11 j=1,it
			sum=sum + func(x)
			x=x + del
 11		continue
 		s=0.5*(s+(b-a)*sum/tnm)		!This replaces s by its refined value
	end if
	return
	end
	
	
	SUBROUTINE polint(xa,ya,n,x,y,dy)
	INTEGER n,NPMAX
	REAL*8 dy,x,y,xa(n),ya(n)
	PARAMETER (NPMAX=5001)	!Largest anticipated value of n
c	Given arrays xa and ya, each of length n, and given a value x, this routine 
c	returns a value y, and an error estimate dy. If P(x) is the polynomial of 
c	degree N-1 such that P(xai)=yai, i= 1, 2,  , n, then the returned value
c	y= P(x). This subroutine implements Neville's algorithm.
	INTEGER i,m,ns
	REAL*8 den,dif,dift,ho,hp,w,c(NPMAX),d(NPMAX)
	ns=1
	dif=abs(x-xa(1))
	do 11 i=1,n		!Here we find the index ns of the closest table entry
		dift = abs(x-xa(i))
		if (dift .lt. dif) then
			ns = i
			dif = dift
		end if
		c(i) = ya(i)	!and initialize the tableau of c's and d's
		d(i) = ya(i)
 11	continue
 	y=ya(ns)			!This is the initial approximation to y
	ns = ns -1
	do 13 m=1,n-1		!For each column of the tableau
c						 we loop over the current c's and d's and update them.
		do 12 i=1,n-m
			ho=xa(i) - x
			hp=xa(i+m) - x
			w=c(i+1) - d(i)
			den = ho - hp
			if (den .eq. 0) then
				write(*,*) 'failure in polint'	!This error can occur only if two input xa's
				stop							!are (to within roundoff) identical
			end if
			den = w/den
			d(i) = hp * den		!Here the c's and d's are updated
			c(i) = ho * den
 12		continue
 		if (2 * ns .lt. n-m) then	!After each column in the tableau is completed, we decide
			dy=c(ns+1)				!which correction, c or d, we want to add to our accumulating
		else						!value of y, i.e., which path to take through the tableau-
			dy=d(ns)				!forking up or down. We do this in such a way as to take the
			ns = ns - 1				!most straight line route through the tableau to its apex, updating
		end if						!ns accordingly to keep track of where we are. This route keeps
		y = y + dy					!the partial approximation centered (insofar as possible) on the
 13	continue						!target x. The last dy added is thus the error indication
 	return
	END
			



	   
	   SUBROUTINE derivs(x,y,dydx)
           IMPLICIT DOUBLE PRECISION (A-H,O-Z)
           PARAMETER (NMAXEIG=200)
           COMMON /DADOS/ NEIGEN,EV(NMAXEIG),UNU,APTT,K,NFLOW	!K  o nmero de ordem do eigenvalue
           INTEGER NMAX
	   PARAMETER (NMAX=50)
	   REAL*8 x,yaux,y(NMAX),dydx(NMAX),UNU,APTT
c   User supplied subroutine with the derivative
c           dydx(1)=x+y(1)   				!y'=y+x  whose solution is y=exp(x)-x-1
c           dydx(2)=y(2)+(x-1)*(x-1)			!y'=y+(x-1)**2 solution is y=exp(x)-x**2-1
           SMALL=1.0D-30
           yaux=(3.+NFLOW)/2.*UNU*x**NFLOW*(1.-x*x)*(1.+APTT*(1.+x*x))
           dydx(1)=-EV(k)*EV(k)*yaux*y(2)
	   dydx(2)=y(1)/(x**NFLOW+SMALL)
           dydx(3)=-EV(k)*yaux*(EV(k)*y(4)+2.*y(2))
	   dydx(4)=y(3)/(x**NFLOW+SMALL)
	   return
	   END
	   
	   
	REAL*8 FUNCTION func(x)
	PARAMETER(NPMAX=5000)	!NMAX is maximum number of points
        COMMON /INTDATA/ A,B,XF,YF,npoints,YF2
        REAL*8 A,B,XF(NPMAX),YF(NPMAX),YF2(NPMAX)
	REAL*8 x,y,dy
	INTEGER npoints

c        WRITE(*,*)'into the function'        


        call splint(XF,YF,YF2,npoints+1,x,y)
	func=y

	RETURN
	END

       SUBROUTINE spline(x,y,n,yp1,ypn,y2)
       INTEGER n,NPMAX
       REAL*8 yp1,ypn,x(n),y(n),y2(n)
       PARAMETER (NPMAX=5000)
c    Given arrays x(1:n) and y(1:n) containing a tabulated function, i.e., yi=f(xi), with
c    x1 < x2 < ... < xn, and given values yp1 and ypn for the first derivative of the
c    interpolating function at points 1 and n, respectively, this routine returns an 
c    array y2(1:n) of length n which contains the second derivatives of the interpolating
c    function at the tabulated points xi. If yp1 and/or ypn are equal to 1 x 10^30 or larger,
c    the routine is signaled to set the corresponding boundary condition for a natural spline,
c    with zero second derivative on that boundary.
c    Parameter: NMAX is the largest anticipated value of n
       
       INTEGER i,k
       REAL*8 p,qn,sig,un,u(NPMAX)
       if (yp1 .gt. 0.99e30) then		!The lower boundary condition is set either to be "natural"
          y2(1)=0.
	  u(1)=0.
       else				!or else to have a specified first derivative.
          y2(1)=-0.5
	  u(1)=(3./(x(2)-x(1)))*((y(2)-y(1))/(x(2)-x(1))-yp1)
       endif
       
       do 11 i=2,n-1				!This is the decomposition loop of the tridiagonal
          sig=(x(i)-x(i-1))/(x(i+1)-x(i-1))	!algorithm. y2 and u are used for temporary
	  p=sig*y2(i-1)+2.			!storage of the decomposed factors.
	  y2(i)=(sig-1.)/p
	  u(i)=(6.*((y(i+1)-y(i))/(x(i+1)-x(i))-(y(i)-y(i-1))
     *     /(x(i)-x(i-1)))/(x(i+1)-x(i-1))-sig*u(i-1))/p
 11    continue
 
       if (ypn .gt. 0.99e30) then			!The upper boundary condition is set either to be
          qn=0.						! "natural"
	  un=0.
       else						!or else to have a specified first derivative
          qn=0.5
	  un=(3./(x(n)-x(n-1)))*(ypn-(y(n)-y(n-1))/(x(n)-x(n-1)))
       endif
       
       y2(n)=(un-qn*u(n-1))/(qn*y2(n-1)+1.)
       do 12 k=n-1,1,-1					!This is the backsubstitution loop of the
          y2(k)=y2(k)*y2(k+1)+u(k)			!tridiagonal algorithm
 12    continue
       return
       END
       
       
          
        SUBROUTINE splint(xa,ya,y2a,n,x,y)
	INTEGER n
	REAL*8 x,y,xa(n),y2a(n),ya(n)
c     Given the arrays xa(1:n) and ya(1:n) of length n, which tabulate a function (with the
c     xai's in order), and given the array y2a(1:n), which is the output from spline above,
c     and given a value of x, this routine returns a cubic-spline interpolated value y.
        INTEGER k,khi,klo
	REAL*8 a,b,h
	klo=1				!We will find the right place in the table by means of bisection
	khi=n				!This is optimal if sequential calls to this routine are at random
 1      if (khi-klo .gt. 1) then	!values of x. If sequential calls are inorder, and closely spaced
           k=(khi+klo)/2.		!one would do better to store previous values of klo and khi and
	   if (xa(k) .gt. x) then	!test if they remain appropriate on the next call.
	      khi=k
	   else
	      klo=k
	   endif			
	goto 1
	endif				!klo and khi now bracket the input value of x.
	h=xa(khi)-xa(klo)
	
	if (h .eq. 0.) pause 'bad xa input in splint'  !The xa's must be distinct
	a=(xa(khi)-x)/h			!Cubic spline polynomial now evaluated
	b=(x-xa(klo))/h
	y=a*ya(klo)+b*ya(khi)+
     *    ((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**2)/6.
        return
	END
	
		  
